# (C) Copyright 2003 Nuxeo SARL <http://nuxeo.com>
# Author: Florent Guillaume <fg@nuxeo.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: __init__.py,v 1.11 2004/02/19 11:29:38 ben Exp $

from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.CMFCorePermissions import ManagePortal

import Field
import Schema
import Layout

import VocabulariesTool
from VocabulariesTool import VocabularyTypeRegistry
from Vocabulary import CPSVocabulary

import SchemasTool
import LayoutsTool
import WidgetTypesTool

import BasicFields
import BasicWidgets
import ExtendedWidgets

import EpozPatch

tools = (
    VocabulariesTool.VocabulariesTool,
    SchemasTool.SchemasTool,
    LayoutsTool.LayoutsTool,
    WidgetTypesTool.WidgetTypesTool,
    )

registerDirectory('skins', globals())

def initialize(registrar):
    registrar.registerClass(
        Schema.CPSSchema,
        permission=ManagePortal,
        constructors=(Schema.addCPSSchemaForm,
                      Schema.addCPSSchema,),
        )
    utils.ToolInit(
        'CPS Document Tools',
        tools = tools,
        product_name = 'CPSSchemas',
        icon = 'tool.gif',
        ).initialize(registrar)
    VocabularyTypeRegistry.register(CPSVocabulary)
